main()
{
	//maps\mp\mp_pyramid_fx::main();
	//maps\createart\mp_pyramid_art::main();
	maps\mp\_load::main();	
	
	maps\mp\_compass::setupMiniMap("compass_map_mp_pyramid");

	//setExpFog(500, 2200, 0.81, 0.75, 0.63, 0);
	//VisionSetNaked( "mp_pyramid" );
	ambientPlay("ambient_pyramid_ext");

	game["allies"] = "sas";
	game["axis"] = "opfor";
	game["attackers"] = "axis";
	game["defenders"] = "allies";
	game["allies_soldiertype"] = "woodland";
	game["axis_soldiertype"] = "woodland";

	setdvar( "r_specularcolorscale", "1" );
	setdvar("r_glowbloomintensity0",".25");
	setdvar("r_glowbloomintensity1",".25");
	setdvar("r_glowskybleedintensity0",".3");
	setdvar("compassmaxrange","1800");

	//fx
	level._effect["fire_altar"] = loadfx ("fire/firelp_small_pm_no_smoke");
	level._effect["water_fountain"] = loadfx ("impacts/water_fountain");
	level._effect["fire"] = loadfx ("fire/flame_small_em");
	level.fx_trap_earth = loadfx("explosions/pyramid_earth");
	level.fx_trap_fire = loadfx("explosions/pyramid_fire");
	level.fx_trap_fire_small = loadfx("explosions/pyramid_fire_small");
	level.fx_trap_water = loadfx("misc/pyramid_water");

	//trap code
	trig_trap_upper = getent("trig_trap_upper","targetname");
	level.trap_upper_attacker = "";
	level.trap_upper = false;
	trig_trap_upper thread trig_trap_upper_hurt();

	trig_trap_earth = getent("trig_trap_earth","targetname");
	level.trap_earth_attacker = "";
	level.trap_earth = false;
	trig_trap_earth thread trig_trap_earth_hurt();

	trig_trap_fire = getent("trig_trap_fire","targetname");
	level.trap_fire_attacker = "";
	level.trap_fire = false;
	trig_trap_fire thread trig_trap_fire_hurt();

	trig_trap_water = getent("trig_trap_water","targetname");
	level.trap_water_attacker = "";
	level.trap_water = false;
	trig_trap_water thread trig_trap_water_hurt();

	trig_trap_air = getent("trig_trap_air","targetname");
	level.trap_air_attacker = "";
	level.trap_air = false;
	trig_trap_air.windpoints = 11;
	trig_trap_air.windpointhigh = 6;
	trig_trap_air.time = 0.25;
	trig_trap_air.windpoint[0] = getent(trig_trap_air.target, "targetname");
	for(i=1;i<trig_trap_air.windpoints;i++)
	{
		trig_trap_air.windpoint[i] = getent(trig_trap_air.windpoint[i-1].target, "targetname");
	}
	trig_trap_air thread trig_trap_air_hurt();

	//torch code
	torch = getentarray("torch","targetname");
	for(i=0;i<torch.size;i++)
	{
		torch[i] thread torchfire();
	}

	//fountain code
	fountain = getentarray("altar_water","targetname");
	for(i=0;i<fountain.size;i++)
	{
		fountain[i] thread fountain_spray();
	}

	//fire code
	altar_fire = getentarray("altar_fire","targetname");
	for(i=0;i<altar_fire.size;i++)
	{
		altar_fire[i] thread fire_burn();
	}

	//button code
	trig_button_upper = getentarray("trig_button_upper","targetname");
	for(i=0;i<trig_button_upper.size;i++)
	{
		trig_button_upper[i].lasermax = 4;
		trig_button_upper[i].button = getent(trig_button_upper[i].target, "targetname");
		trig_button_upper[i].laser[0] = getent(trig_button_upper[i].button.target, "targetname");
		for(j=1;j<trig_button_upper[i].lasermax;j++)
		{
			trig_button_upper[i].laser[j] = getent(trig_button_upper[i].laser[j-1].target, "targetname");
		}
		trig_button_upper[i].laserhurt[0] = getent(trig_button_upper[i].laser[trig_button_upper[i].lasermax-1].target, "targetname");
		for(j=1;j<trig_button_upper[i].lasermax;j++)
		{
			trig_button_upper[i].laserhurt[j] = getent(trig_button_upper[i].laserhurt[j-1].target, "targetname");
		}
		trig_button_upper[i].fx_point = getent(trig_button_upper[i].laserhurt[trig_button_upper[i].lasermax-1].target, "targetname");
		for(j=0;j<trig_button_upper[i].lasermax;j++)
		{
			trig_button_upper[i].laser[j] hide();
			trig_button_upper[i].laser[j] notSolid();
			if (trig_button_upper[i].script_noteworthy == "east")
			{
				level.laser_east_attacker[j] = "";
				level.laser_east[j] = false;
			}
			else if (trig_button_upper[i].script_noteworthy == "west")
			{
				level.laser_west_attacker[j] = "";
				level.laser_west[j] = false;
			}
		}		
		for(j=0;j<trig_button_upper[i].lasermax;j++)
		{
			trig_button_upper[i].laserhurt[j] thread trig_laser_hurt_upper(trig_button_upper[i].script_noteworthy, j);
		}		
		trig_button_upper[i] thread button_upper();
	}

	trig_button_fire = getent("trigger_button_fire","targetname");
	trig_button_fire.lasermax = 4;
	trig_button_fire.button = getent(trig_button_fire.target, "targetname");
	trig_button_fire.laser[0] = getent(trig_button_fire.button.target, "targetname");
	for(j=1;j<trig_button_fire.lasermax;j++)
	{
		trig_button_fire.laser[j] = getent(trig_button_fire.laser[j-1].target, "targetname");
	}
	trig_button_fire.laserhurt[0] = getent(trig_button_fire.laser[trig_button_fire.lasermax-1].target, "targetname");
	for(j=1;j<trig_button_fire.lasermax;j++)
	{
		trig_button_fire.laserhurt[j] = getent(trig_button_fire.laserhurt[j-1].target, "targetname");
	}
	trig_button_fire.fx_point = getent(trig_button_fire.laserhurt[trig_button_fire.lasermax-1].target, "targetname");
	for(j=0;j<trig_button_fire.lasermax;j++)
	{
		trig_button_fire.laser[j] hide();
		trig_button_fire.laser[j] notSolid();
		level.laser_fire_attacker[j] = "";
		level.laser_fire[j] = false;
	}		
	for(j=0;j<trig_button_fire.lasermax;j++)
	{
		trig_button_fire.laserhurt[j] thread trig_laser_hurt_fire(j);
	}		
	trig_button_fire thread button_fire();

	trig_button_earth = getent("trigger_button_earth","targetname");
	trig_button_earth.lasermax = 4;
	trig_button_earth.button = getent(trig_button_earth.target, "targetname");
	trig_button_earth.laser[0] = getent(trig_button_earth.button.target, "targetname");
	for(j=1;j<trig_button_earth.lasermax;j++)
	{
		trig_button_earth.laser[j] = getent(trig_button_earth.laser[j-1].target, "targetname");
	}
	trig_button_earth.laserhurt[0] = getent(trig_button_earth.laser[trig_button_earth.lasermax-1].target, "targetname");
	for(j=1;j<trig_button_earth.lasermax;j++)
	{
		trig_button_earth.laserhurt[j] = getent(trig_button_earth.laserhurt[j-1].target, "targetname");
	}
	trig_button_earth.fx_point = getent(trig_button_earth.laserhurt[trig_button_earth.lasermax-1].target, "targetname");
	for(j=0;j<trig_button_earth.lasermax;j++)
	{
		trig_button_earth.laser[j] hide();
		trig_button_earth.laser[j] notSolid();
		level.laser_earth_attacker[j] = "";
		level.laser_earth[j] = false;
	}		
	for(j=0;j<trig_button_earth.lasermax;j++)
	{
		trig_button_earth.laserhurt[j] thread trig_laser_hurt_earth(j);
	}		
	trig_button_earth thread button_earth();

	trig_button_water = getent("trigger_button_water","targetname");
	trig_button_water.lasermax = 4;
	trig_button_water.button = getent(trig_button_water.target, "targetname");
	trig_button_water.laser[0] = getent(trig_button_water.button.target, "targetname");
	for(j=1;j<trig_button_water.lasermax;j++)
	{
		trig_button_water.laser[j] = getent(trig_button_water.laser[j-1].target, "targetname");
	}
	trig_button_water.laserhurt[0] = getent(trig_button_water.laser[trig_button_water.lasermax-1].target, "targetname");
	for(j=1;j<trig_button_water.lasermax;j++)
	{
		trig_button_water.laserhurt[j] = getent(trig_button_water.laserhurt[j-1].target, "targetname");
	}
	trig_button_water.fx_point = getent(trig_button_water.laserhurt[trig_button_water.lasermax-1].target, "targetname");
	for(j=0;j<trig_button_water.lasermax;j++)
	{
		trig_button_water.laser[j] hide();
		trig_button_water.laser[j] notSolid();
		level.laser_water_attacker[j] = "";
		level.laser_water[j] = false;
	}		
	for(j=0;j<trig_button_water.lasermax;j++)
	{
		trig_button_water.laserhurt[j] thread trig_laser_hurt_water(j);
	}		
	trig_button_water thread button_water();

	trig_button_air = getent("trigger_button_air","targetname");
	trig_button_air.lasermax = 4;
	trig_button_air.button = getent(trig_button_air.target, "targetname");
	trig_button_air.laser[0] = getent(trig_button_air.button.target, "targetname");
	for(j=1;j<trig_button_air.lasermax;j++)
	{
		trig_button_air.laser[j] = getent(trig_button_air.laser[j-1].target, "targetname");
	}
	trig_button_air.laserhurt[0] = getent(trig_button_air.laser[trig_button_air.lasermax-1].target, "targetname");
	for(j=1;j<trig_button_air.lasermax;j++)
	{
		trig_button_air.laserhurt[j] = getent(trig_button_air.laserhurt[j-1].target, "targetname");
	}
	trig_button_air.fx_point = getent(trig_button_air.laserhurt[trig_button_air.lasermax-1].target, "targetname");
	for(j=0;j<trig_button_air.lasermax;j++)
	{
		trig_button_air.laser[j] hide();
		trig_button_air.laser[j] notSolid();
		level.laser_air_attacker[j] = "";
		level.laser_air[j] = false;
	}		
	for(j=0;j<trig_button_air.lasermax;j++)
	{
		trig_button_air.laserhurt[j] thread trig_laser_hurt_air(j);
	}		
	trig_button_air thread button_air();

	//door code
	trig_door_tall = getentarray("trig_door_tall","targetname");
	for(i=0;i<trig_door_tall.size;i++)
	trig_door_tall[i] thread doorslide_think("down", 104, 1);

	trig_door_short = getentarray("trig_door_short","targetname");
	for(i=0;i<trig_door_short.size;i++)
	trig_door_short[i] thread doorslide_think("down", 84, 1);

	trig_door_mummy = getentarray("trig_door_mummy","targetname");
	for(i=0;i<trig_door_mummy.size;i++)
	trig_door_mummy[i] thread doorslide_think("west", 52, 1);

	trig_door_prison = getentarray("trig_door_prison","targetname");
	for(i=0;i<trig_door_prison.size;i++)
	trig_door_prison[i] thread doorslide_think(trig_door_prison[i].script_noteworthy, 46, 1);

	trig_altar_earth = getentarray("trig_altar_earth","targetname");
	for(i=0;i<trig_altar_earth.size;i++)
	trig_altar_earth[i] thread doorslide_think("west", 144, 3);

	trig_altar_air = getentarray("trig_altar_air","targetname");
	for(i=0;i<trig_altar_air.size;i++)
	trig_altar_air[i] thread doorslide_think("east", 144, 3);
}

//trig_trap_upper
trig_trap_upper_hurt()
{
	while (true)
	{
		self waittill("trigger", user);
		{
			if(level.trap_upper)
			{
				RadiusDamage(user.origin, 1, 10, 10, level.trap_upper_attacker);
			}
		}
		wait(0.1);
	}
}

//trig_trap_fire
trig_trap_fire_hurt()
{
	while (true)
	{
		self waittill("trigger", user);
		{
			if(level.trap_fire)
			{
				RadiusDamage(user.origin, 1, 10, 10, level.trap_fire_attacker);
			}
		}
		wait(0.1);
	}
}

//trig_trap_earth
trig_trap_earth_hurt()
{
	while (true)
	{
		self waittill("trigger", user);
		{
			if(level.trap_earth)
			{
				RadiusDamage(user.origin, 1, 10, 10, level.trap_earth_attacker);
			}
		}
		wait(0.1);
	}
}

//trig_trap_water
trig_trap_water_hurt()
{
	while (true)
	{
		self waittill("trigger", user);
		{
			if(level.trap_water)
			{
				RadiusDamage(user.origin, 1, 10, 10, level.trap_water_attacker);
			}
		}
		wait(0.1);
	}
}

//trig_trap_air
trig_trap_air_hurt()
{
	while (true)
	{
		self waittill("trigger", user);
		{
			if(level.trap_air)
			{
				air = spawn ("script_model",(0,0,0));
			        air.origin = user.origin;
				air.angles = user.angles;
				user linkto (air);
				for(i=0;i<self.windpoints;i++)
				{
					air moveto (self.windpoint[i].origin, self.time);
					air waittill("movedone");
				}
				user unlink();
				wait(0.5);
				RadiusDamage(user.origin, 1, 70, 70, level.trap_air_attacker);
				level.trap_air = false;
			}
		}
		wait(0.1);
	}
}

//trig_laser_hurt
trig_laser_hurt_upper(lasereastwest, laserindex)
{
	while (true)
	{
		self waittill("trigger", user);
		{
			if(lasereastwest == "east" && level.laser_east[laserindex])
			{
				RadiusDamage(user.origin, 1, 10, 10, level.laser_east_attacker[laserindex]);
			}
			else if(lasereastwest == "west" && level.laser_west[laserindex])
			{
				RadiusDamage(user.origin, 1, 10, 10, level.laser_west_attacker[laserindex]);
			}
		}
		wait(0.1);
	}
}

trig_laser_hurt_fire(laserindex)
{
	while (true)
	{
		self waittill("trigger", user);
		{
			if(level.laser_fire[laserindex])
			{
				RadiusDamage(user.origin, 1, 10, 10, level.laser_fire_attacker[laserindex]);
			}
		}
		wait(0.1);
	}
}

trig_laser_hurt_earth(laserindex)
{
	while (true)
	{
		self waittill("trigger", user);
		{
			if(level.laser_earth[laserindex])
			{
				RadiusDamage(user.origin, 1, 10, 10, level.laser_earth_attacker[laserindex]);
			}
		}
		wait(0.1);
	}
}

trig_laser_hurt_water(laserindex)
{
	while (true)
	{
		self waittill("trigger", user);
		{
			if(level.laser_water[laserindex])
			{
				RadiusDamage(user.origin, 1, 10, 10, level.laser_water_attacker[laserindex]);
			}
		}
		wait(0.1);
	}
}

trig_laser_hurt_air(laserindex)
{
	while (true)
	{
		self waittill("trigger", user);
		{
			if(level.laser_air[laserindex])
			{
				RadiusDamage(user.origin, 1, 10, 10, level.laser_air_attacker[laserindex]);
			}
		}
		wait(0.1);
	}
}

//button code
button_upper()
{
	self.buttonbusy = false;
	self.time = 0.1;
	while (1)
	{
		self waittill("trigger", user);
		if(!self.buttonbusy)
		{
			self.buttonbusy = true;
			self.button movez(-2,self.time,0.5 * self.time,0.5 * self.time);
			self.button playsound("button");
			self.button waittill("movedone");
			for(i=0;i<self.lasermax;i++)
			{
				self.laser[i] show();
				self.laser[i] playsound("laser");
				if (self.script_noteworthy == "east")
				{
					level.laser_east_attacker[i] = user;
					level.laser_east[i] = true;
				}
				else if (self.script_noteworthy == "west")
				{
					level.laser_west_attacker[i] = user;
					level.laser_west[i] = true;
				}
				wait(0.05);
			}
			PlayFX(level.fx_trap_fire, self.fx_point.origin);
			self.fx_point playsound("explosion");
			level.trap_upper_attacker = user;
			level.trap_upper = true;
			wait(0.75);
			level.trap_upper = false;
			for(i=0;i<self.lasermax;i++)
			{
				if (self.script_noteworthy == "east")
				{
					level.laser_east[i] = false;
				}
				else if (self.script_noteworthy == "west")
				{
					level.laser_west[i] = false;
				}
				self.laser[i] hide();
			}
			self.button movez(2,self.time,0.5 * self.time,0.5 * self.time);
			self.button waittill("movedone");
			wait(3);
			self.buttonbusy = false;
		}
	}
}

button_fire()
{
	self.buttonbusy = false;
	self.time = 0.1;
	while (1)
	{
		self waittill("trigger", user);
		if(!self.buttonbusy)
		{
			self.buttonbusy = true;
			self.button movez(-2,self.time,0.5 * self.time,0.5 * self.time);
			self.button playsound("button");
			self.button waittill("movedone");
			for(i=0;i<self.lasermax;i++)
			{
				self.laser[i] show();
				self.laser[i] playsound("laser");
				level.laser_fire_attacker[i] = user;
				level.laser_fire[i] = true;
				wait(0.05);
			}
			PlayFX(level.fx_trap_fire, self.fx_point.origin);
			self.fx_point playsound("explosion");
			level.trap_fire_attacker = user;
			level.trap_fire = true;
			wait(0.75);
			level.trap_fire = false;
			for(i=0;i<self.lasermax;i++)
			{
				level.laser_fire[i] = false;
				self.laser[i] hide();
			}
			self.button movez(2,self.time,0.5 * self.time,0.5 * self.time);
			self.button waittill("movedone");			
			wait(3);
			self.buttonbusy = false;
		}
	}
}

button_earth()
{
	self.buttonbusy = false;
	self.time = 0.1;
	while (1)
	{
		self waittill("trigger", user);
		if(!self.buttonbusy)
		{
			self.buttonbusy = true;
			self.button movez(-2,self.time,0.5 * self.time,0.5 * self.time);
			self.button playsound("button");
			self.button waittill("movedone");
			for(i=0;i<self.lasermax;i++)
			{
				self.laser[i] show();
				self.laser[i] playsound("laser");
				level.laser_earth_attacker[i] = user;
				level.laser_earth[i] = true;
				wait(0.05);
			}
			PlayFX(level.fx_trap_earth, self.fx_point.origin);
			self.fx_point playsound("explosion");
			level.trap_earth_attacker = user;
			level.trap_earth = true;
			wait(0.75);
			level.trap_earth = false;
			for(i=0;i<self.lasermax;i++)
			{
				level.laser_earth[i] = false;
				self.laser[i] hide();
			}
			self.button movez(2,self.time,0.5 * self.time,0.5 * self.time);
			self.button waittill("movedone");			
			wait(3);
			self.buttonbusy = false;
		}
	}
}

button_water()
{
	self.buttonbusy = false;
	self.time = 0.1;
	while (1)
	{
		self waittill("trigger", user);
		if(!self.buttonbusy)
		{
			self.buttonbusy = true;
			self.button movez(-2,self.time,0.5 * self.time,0.5 * self.time);
			self.button playsound("button");
			self.button waittill("movedone");
			for(i=0;i<self.lasermax;i++)
			{
				self.laser[i] show();
				self.laser[i] playsound("laser");
				level.laser_water_attacker[i] = user;
				level.laser_water[i] = true;
				wait(0.05);
			}
			PlayFX(level.fx_trap_water, self.fx_point.origin);
			self.fx_point playsound("splash");
			level.trap_water_attacker = user;
			level.trap_water = true;
			wait(0.75);
			level.trap_water = false;
			for(i=0;i<self.lasermax;i++)
			{
				level.laser_water[i] = false;
				self.laser[i] hide();
			}
			self.button movez(2,self.time,0.5 * self.time,0.5 * self.time);
			self.button waittill("movedone");			
			wait(3);
			self.buttonbusy = false;
		}
	}
}

button_air()
{
	self.buttonbusy = false;
	self.time = 0.1;
	while (1)
	{
		self waittill("trigger", user);
		if(!self.buttonbusy)
		{
			self.buttonbusy = true;
			self.button movez(-2,self.time,0.5 * self.time,0.5 * self.time);
			self.button playsound("button");
			self.button waittill("movedone");
			for(i=0;i<self.lasermax;i++)
			{
				self.laser[i] show();
				self.laser[i] playsound("laser");
				level.laser_air_attacker[i] = user;
				level.laser_air[i] = true;
				wait(0.05);
			}
			self.fx_point playsound("wind");
			level.trap_air_attacker = user;
			level.trap_air = true;
			wait(0.75);
			level.trap_air = false;
			for(i=0;i<self.lasermax;i++)
			{
				level.laser_air[i] = false;
				self.laser[i] hide();
			}
			self.button movez(2,self.time,0.5 * self.time,0.5 * self.time);
			self.button waittill("movedone");			
			wait(3);
			self.buttonbusy = false;
		}
	}
}

//door code
doorslide_think(direction, distance, time)
{
	self.doormoving = false;
	self.doorclosed = true;
	self.doormodel = getent(self.target, "targetname");
	self.distance = distance;
	self.direction = direction;
	self.time = time;

	while (1)
	{
		self waittill("trigger");
		if(!self.doormoving)
		{
			self.doormoving = true;
			if(self.doorclosed)
			{
				if (self.direction == "west")
				{
					self.doormodel movex(-1 * self.distance,self.time,0.5 * self.time,0.5 * self.time);
				}
				else if (self.direction == "east")
				{
					self.doormodel movex(self.distance,self.time,0.5 * self.time,0.5 * self.time);
				}
				else if (self.direction == "north")
				{
					self.doormodel movey(self.distance,self.time,0.5 * self.time,0.5 * self.time);
				}
				else if (self.direction == "south")
				{
					self.doormodel movey(-1 * self.distance,self.time,0.5 * self.time,0.5 * self.time);
				}
				else if (self.direction == "up")
				{
					self.doormodel movez(self.distance,self.time,0.5 * self.time,0.5 * self.time);
				}
				else if (self.direction == "down")
				{
					self.doormodel movez(-1 * self.distance,self.time,0.5 * self.time,0.5 * self.time);
				}
				self.doormodel playsound("doorslide");
				self.doormodel waittill("movedone");
				self.doorclosed = false;

				//close door again
				wait 4;
				if (self.direction == "west")
				{
					self.doormodel movex(self.distance,self.time,0.5 * self.time,0.5 * self.time);
				}
				else if (self.direction == "east")
				{
					self.doormodel movex(-1 * self.distance,self.time,0.5 * self.time,0.5 * self.time);
				}
				else if (self.direction == "north")
				{
					self.doormodel movey(-1 * self.distance,self.time,0.5 * self.time,0.5 * self.time);
				}
				else if (self.direction == "south")
				{
					self.doormodel movey(self.distance,self.time,0.5 * self.time,0.5 * self.time);
				}
				else if (self.direction == "up")
				{
					self.doormodel movez(-1 * self.distance,self.time,0.5 * self.time,0.5 * self.time);
				}
				else if (self.direction == "down")
				{
					self.doormodel movez(self.distance,self.time,0.5 * self.time,0.5 * self.time);
				}
				self.doormodel playsound("doorslide");
				self.doormodel waittill("movedone");
				self.doorclosed = true;		
			}
			self.doormoving = false;
		}
	}
}

//fire_burn
fire_burn()
{
	maps\mp\_fx::loopfx("fire_altar", (self.origin + (0, 0, 16)), 0.5);
	while (true)
	{
		RadiusDamage((self.origin + (0, 0, 20)), 32, 15, 10);
		wait(0.5);
	}
}

//fountain_spray
fountain_spray()
{
	maps\mp\_fx::loopfx("water_fountain", (self.origin + (0, 0, 8)), 0.5);
}

//torch code
torchfire()
{
	maps\mp\_fx::loopfx("fire", (self.origin + (0, 0, 16)), 0.5);	
	while (true)
	{
		RadiusDamage((self.origin + (0, 0, 20)), 32, 15, 10);
		wait(0.5);
	}
}